searchData={"items":[{"type":"module","title":"ReqClientCredentials","doc":"`Req` plugin for [OAuth 2.0 client credentials flow][rfc] authentication. The\naccess token will be cached and reused for subsequent requests, if the\nresponse to the `:url` returns a 401 response then this plugin will refresh\nthe access token (only refreshes one time). If an `:audience` is included in\n`:client_credentials_params` then this plugin will only run if the schema,\nhost, and port of the `:url` match that of the `:audience`.\n\n[rfc]: https://datatracker.ietf.org/doc/html/rfc6749#section-4.4","ref":"ReqClientCredentials.html"},{"type":"function","title":"ReqClientCredentials.attach/2","doc":"Runs the plugin.","ref":"ReqClientCredentials.html#attach/2"},{"type":"function","title":"Usage - ReqClientCredentials.attach/2","doc":"req =\n      Req.new(\n        client_credentials_params: [\n          audience: \"https://api.example.com\",\n          client_id: System.get_env(\"EXAMPLE_CLIENT_ID\"),\n          client_secret: System.get_env(\"EXAMPLE_CLIENT_SECRET\")\n        ],\n        client_credentials_url: \"https://auth.example.com/oauth/token\",\n      )\n      |> ReqClientCredentials.attach()\n    Req.get!(req, url: \"https://api.example.com/path\")\n    #=> %Req.Response{}","ref":"ReqClientCredentials.html#attach/2-usage"},{"type":"extras","title":"ReqClientCredentials","doc":"# ReqClientCredentials\n\n`Req` plugin for [OAuth 2.0 client credentials flow][rfc] authentication. The\naccess token will be cached and reused for subsequent requests, if the\nresponse to the `:url` returns a 401 response then this plugin will refresh\nthe access token (only refreshes one time). If an `:audience` is included in\n`:client_credentials_params` then this plugin will only run if the schema,\nhost, and port of the `:url` match that of the `:audience`.","ref":"readme.html"},{"type":"extras","title":"Usage - ReqClientCredentials","doc":"```elixir\nreq =\n  Req.new(\n    client_credentials_params: [\n      audience: \"https://api.example.com\",\n      client_id: System.get_env(\"EXAMPLE_CLIENT_ID\"),\n      client_secret: System.get_env(\"EXAMPLE_CLIENT_SECRET\")\n    ],\n    client_credentials_url: \"https://auth.example.com/oauth/token\",\n  )\n  |> ReqClientCredentials.attach()\nReq.get!(req, url: \"https://api.example.com/path\")\n#=> %Req.Response{}\n```\n\n[rfc]: https://datatracker.ietf.org/doc/html/rfc6749#section-4.4","ref":"readme.html#usage"},{"type":"extras","title":"CHANGELOG","doc":"# CHANGELOG","ref":"changelog.html"},{"type":"extras","title":"v0.1.1 (2025-07-16) - CHANGELOG","doc":"* Plugin \"detaches\" itself before making token request.","ref":"changelog.html#v0-1-1-2025-07-16"},{"type":"extras","title":"v0.1.0 (2025-07-16) - CHANGELOG","doc":"* Initial release.","ref":"changelog.html#v0-1-0-2025-07-16"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}